import { Mutation } from './mutation';
import { CommandClass, OptionClass } from '../interfaces';
import { handlers } from '../constants/metadata';
export interface CommandFunctionMap {
    [key: string]: CommandClass;
}
export interface OptionFunctionMap {
    [key: string]: OptionClass;
}
export declare type ContainerParams = Array<CommandClass | OptionClass>;
export interface ContainerData {
    [handlers.COMMAND]: CommandClass[];
    [handlers.OPTION]: OptionClass[];
    [handlers.NOT_FOUND]: CommandClass[];
    [handlers.MAJOR]: CommandClass[];
}
export declare class Container {
    private params;
    mutation: Mutation;
    datas: ContainerData;
    constructor(params: ContainerParams);
    getCommands(): CommandClass[];
    private init;
    private insert;
}
