"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mutation_1 = require("./mutation");
const metadata_1 = require("../constants/metadata");
class Container {
    constructor(params) {
        this.params = params;
        this.datas = {
            [metadata_1.handlers.COMMAND]: [],
            [metadata_1.handlers.OPTION]: [],
            [metadata_1.handlers.NOT_FOUND]: [],
            [metadata_1.handlers.MAJOR]: [],
        };
        this.mutation = new mutation_1.Mutation();
        this.init();
        this.insert();
    }
    getCommands() {
        return this.datas[metadata_1.handlers.COMMAND]
            .map(fn => Reflect.getMetadata(metadata_1.metadata.COMMAND_IDENTIFIER, fn));
    }
    init() {
        this.params.forEach(handler => {
            const type = Reflect.getMetadata(metadata_1.metadata.HANDLER_IDENTIFIER, handler);
            const dataColumn = this.datas[type];
            dataColumn && dataColumn.push(handler);
        });
    }
    insert() {
        this.mutation.devour({
            commands: this.datas[metadata_1.handlers.COMMAND],
            options: this.datas[metadata_1.handlers.OPTION],
            notFounds: this.datas[metadata_1.handlers.NOT_FOUND],
            majors: this.datas[metadata_1.handlers.MAJOR],
        });
    }
}
exports.Container = Container;
